﻿@page "/"
@namespace OTaskForce.Pages
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@{ Layout = null; }

<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>OTaskForce</title>
    <base href="~/"/>
    <link rel="stylesheet" href="~/bundle/webapp.bundle.css"/>
    <script src="~/bundle/webapp.bundle.js"></script>
    <script>
        const { shell } = require('electron');
    </script>
    
    @* ReSharper disable Html.PathError *@
    <link rel="stylesheet" href="~/bundle/external/trumbowyg/ui/trumbowyg.min.css"/>
    <link rel="stylesheet" href="~/bundle/external/trumbowyg/plugins/colors/ui/trumbowyg.colors.min.css"/>
    <link rel="stylesheet" href="~/bundle/external/trumbowyg/plugins/emoji/ui/trumbowyg.emoji.min.css"/>
    <link rel="stylesheet" href="~/bundle/external/trumbowyg/plugins/table/ui/trumbowyg.table.min.css"/>
    @* ReSharper restore Html.PathError *@
</head>
<body>
    <component type="typeof(App)" render-mode="ServerPrerendered"/>
    
    @* ReSharper disable Html.PathError *@
    <script src="~/_framework/blazor.server.js"></script>
    @* ReSharper restore Html.PathError *@
    
    <script src="~/bundle/external/acejs/ace.js"></script>
    <script>
        /*
         * Code editor methods
         * (powered by Ace.JS)
         */
        
        global.codeEditor = {};
        global.codeEditor.prepare = (codeEditorElementId) => {
            let codeEditor = ace.edit(codeEditorElementId);
            
            codeEditor.setTheme("ace/theme/nord_dark");
            codeEditor.setShowPrintMargin(false);
            codeEditor.setHighlightActiveLine(true);
            
            codeEditor.session.setNewLineMode("windows");
            codeEditor.session.setTabSize(4);
            codeEditor.session.setUseSoftTabs(true);
            codeEditor.session.setMode("ace/mode/json");
            
            // codeEditor.getSession().getValue()
        };
        global.codeEditor.setValue = (codeEditorElementId, newValue) => {
            ace.edit(codeEditorElementId).getSession().setValue(newValue);
        };
        global.codeEditor.getValue = (codeEditorElementId) => {
            return ace.edit(codeEditorElementId).getSession().getValue();
        };
    </script>
    
    @* ReSharper disable Html.PathError *@
    <script src="~/bundle/external/trumbowyg/trumbowyg.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/base64/trumbowyg.base64.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/colors/trumbowyg.colors.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/emoji/trumbowyg.emoji.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/history/trumbowyg.history.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/preformatted/trumbowyg.preformatted.min.js"></script>
    <script src="~/bundle/external/trumbowyg/plugins/table/trumbowyg.table.min.js"></script>
    @* ReSharper restore Html.PathError *@
    
    <script>
        window.add_rich_text_edit = function (path) {
            $(path).trumbowyg({
                btns: [
                    ['viewHTML'], ['historyUndo','historyRedo'],
                    
                    ['formatting'], ['strong', 'em', 'del'],
                    ['justifyLeft', 'justifyCenter', 'justifyRight', 'justifyFull'],
                    ['unorderedList', 'orderedList'],
                    
                    ['foreColor', 'backColor'],
                    ['superscript', 'subscript'],
                    
                    ['link', 'base64', 'emoji', 'horizontalRule', 'preformatted'],
                    ['removeformat']
                ],
                
                resetCss: true,
                tagsToRemove: ['script', 'link'],
                
                autogrow: true,
                imageWidthModalEdit: true,
                
                urlProtocol: true,
                defaultLinkTarget: '_blank'
            });
        };
        
        window.input_get_value = function (path) {
            return $(path).val();
        }
        window.input_set_value = function (path, new_value) {
            $(path).val(new_value);
        }
    </script>
    
    <!--suppress CssUnusedSymbol -->
    <style>
        .trumbowyg {
            margin: 0;
            border-radius: .3rem !important;
        }
    </style>
</body>
</html>